module main;

import std.stdio;
import demo;

class Square : Shape {
   this( Position pos ) {
      super( pos );
   }

   override string getDescription() const {
      return "Quite square-ish.";
   }
}

void main() {
   // One of the ugliest bugs currently in D: Type inference does not work
   // correctly for arrays of classes sharing a common supertype.
   auto shapes = [
      cast( Shape ) new Circle( new Position( 1, 3 ) ),
      new Square( new Position( 2, 1 ) )
   ];
   
   foreach( shape; shapes ) {
      writeln( toString( shape ) );
   }
}
